#ifndef GDTIFF_H
#define GDTIFF_H

class GdTiff {
 public:
  static const short UNDEF = 0;
  static const short RGB = 1;
  static const short HSV = 2;
  static const short LAB = 3;
  GdTiff(){};
  GdTiff(int width, int height);
  GdTiff(int width, int height, short type);
  GdTiff(char *filename);
  inline double &operator()(unsigned int x, unsigned int y, unsigned int c);
  inline double  operator()(unsigned int x, unsigned int y, unsigned int c) const;
  double* LoadFloatTiff(char *filename);
  void WriteFloatTiff(char *filename);
  void write(char *filename);
  void write_float(char *filename);
  ~GdTiff();
  int width() {return _width;};
  int height() {return _height;};
  void toHSV();
  void toRGB();
  void toLAB();
  int type(){return _type;};
 private:
  double* data;
  int _width;
  int _height;
  int _type;
  int _samplesperpixel; 
  int _bitspersample;
  unsigned short _sampleformat;
};

inline double &GdTiff::operator() (unsigned int x, unsigned int y, unsigned int c) {  
  return data[c + x*4 + y*4*_width];
};
inline double GdTiff::operator() (unsigned int x, unsigned int y, unsigned int c) const {
  return data[c + x*4 + y*4*_width];
};

#endif
